import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Maggot here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Maggot extends Mover
{
    /**
     * Act - do whatever the Maggot wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if( atWorldEdge() )
        {
            turn(15);
            move(3);
        }
        else{
            detectFood();
            detectFoodc();
            detectFoodb();
            getFood();
            getFoodb();
            getFoodc();
            eat();
        }
    }
    
    public boolean detectFood()
    {
        Actor food = getOneObjectAtOffset ( 0, 0, Burger.class );
        return food != null;
    }
    
    public boolean detectFoodb()
    {
        Actor foodb = getOneObjectAtOffset ( -50, 0, Burger.class );
        return foodb != null;
    }
    
    public boolean detectFoodc()
    {
        Actor foodc = getOneObjectAtOffset ( 0, 50, Burger.class );
        return foodc != null;
    }
    
    public void getFood()
    {
        if(detectFood())
        {
            turn(-5);
            move(1);
        }
        else{
            move(1);
            randomTurn();
        }
    }
    
    public void getFoodb()
    {
        if(detectFoodb())
        {
            turn(10);
            move(1);
        }
        else{
            move(1);
            randomTurn();
        }
    }
    
    public void getFoodc()
    {
        if(detectFoodc())
        {
            turn(5);
            move(1);
        }
        else{
            move(1);
            randomTurn();
        }
    }
    
    public void eat()
    {
        Actor burger;
        burger = getOneObjectAtOffset ( 0, 0, Burger.class );
        if(burger != null)
        {
            World world;
            world = getWorld();
            world.removeObject(burger);
            grow();
        }
    }
    
    public void randomTurn()
    {
        if(Greenfoot.getRandomNumber(2) < 1){
            turn(5);
        }
        else{
            turn(-5);
        }
    }
    
    public void grow()
    {
        if(Greenfoot.getRandomNumber(2) < 1){
            placeFly (getX(), getY());
            getWorld().removeObject(this);
        }else{
            getWorld().addObject (new Burger(), Greenfoot.getRandomNumber(600), Greenfoot.getRandomNumber(400));
        }
    }
    
    private void placeFly(int x, int y)
    {
        getWorld().addObject ( new Fly(), x, y );
    }
}
