import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Fly here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Fly extends Mover
{
    /**
     * Act - do whatever the Fly wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if( atWorldEdge() )
        {
            turn(15);
            move(3);
        }
        else{
            detectEnemy();
            detectEnemyb();
            runAway();
            runAwayb();
            randomTurn();
            flySpawn();
            detectFood();
            getFood();
            eat();
            die();
        }
    }
    
    public boolean detectEnemy()
    {
        Actor enemy = getOneObjectAtOffset ( 1000, 0, Spider.class );
        return enemy != null;
    }
    
    public boolean detectEnemyb()
    {
        Actor enemyb = getOneObjectAtOffset ( -100, 0, Spider.class );
        return enemyb != null;
    }
    
    public void runAway()
    {
        if(detectEnemy())
        {
            turn(12);
            move(3);
        }
        else{
            move(1);
        }
    }
    
    public void runAwayb()
    {
        if(detectEnemyb())
        {
            turn(12);
            move(3);
        }
        else{
            move(1);
        }
    }
    
    public void randomTurn()
    {
        if(Greenfoot.getRandomNumber(2) < 1){
            turn(5);
        }
        else{
            turn(-5);
        }
    }
    
    public void flySpawn()
    {
        Actor fly;
        fly = getOneObjectAtOffset ( 0, 0, Fly.class );
        if(fly != null)
        {
            World world;
            world = getWorld();
            world.addObject(new Egg(), Greenfoot.getRandomNumber(600), Greenfoot.getRandomNumber(400));
            world.addObject(new Egg(), Greenfoot.getRandomNumber(600), Greenfoot.getRandomNumber(400));
            world.addObject(new Burger(), Greenfoot.getRandomNumber(600), Greenfoot.getRandomNumber(400));
            world.addObject(new Burger(), Greenfoot.getRandomNumber(600), Greenfoot.getRandomNumber(400));
            move(20);
        }
    }
    
    public void eat()
    {
        Actor burger;
        burger = getOneObjectAtOffset ( 0, 0, Burger.class );
        if(burger != null)
        {
            World world;
            world = getWorld();
            world.removeObject(burger);
            if(Greenfoot.getRandomNumber(4) < 1){
                getWorld().addObject(new Burger(), Greenfoot.getRandomNumber(600), Greenfoot.getRandomNumber(400));
            }
        }
    }
    
    public boolean detectFood()
    {
        Actor food = getOneObjectAtOffset ( -50, 0, Burger.class );
        return food != null;
    }
    
    public void getFood()
    {
        if(detectFood())
        {
            turn(10);
            move(1);
        }
        else{
            move(1);
        }
    }
    
    public void die()
    {
        if(Greenfoot.getRandomNumber(1000) < 1){
            getWorld().addObject(new Burger(), Greenfoot.getRandomNumber(600), Greenfoot.getRandomNumber(400));
            getWorld().removeObject(this);
        }
    }
}
